#
#   logactio  -  simple framework for doing configured action on certain
#                log file events
#
# SPDX-FileCopyrightText: Copyright 2012-  David Sommerseth <dazo@eurephia.org>
# SPDX-License-Identifier: GPL-2.0-only
#

import syslog

LOGTYPE_FILE = 0
LOGTYPE_SYSLOG = 1
LOGTYPE_STDOUT = 2

class FileLogger:
    def __init__(self, logfile):
        self.__logf = open(logfile, "a+")


    def _log(self, lvl, msg):
        self.__logf.write(f"[{lvl}] {msg}\n")
        self.__logf.flush()


    def _close(self):
        self.__logf.close()



class SysLogger:
    def __init__(self, destname):
        syslog.openlog(destname, syslog.LOG_PID|syslog.LOG_NOWAIT, syslog.LOG_USER)


    def _log(self, lvl, msg):
        syslog.syslog(syslog.LOG_NOTICE, msg)


    def _close(self):
        syslog.closelog()


class StdoutLogger:
    def __init__(self):
        import sys
        self.__logf = sys.stdout


    def _log(self, lvl, msg):
        self.__logf.write(f"[{lvl}] {msg}\n")
        self.__logf.flush()


    def _close(self):
        pass


class Logger:
    def __init__(self, logtype, logdest, verblvl):
        self.__verblevel = verblvl
        if logtype == LOGTYPE_FILE:
            self.__logger = FileLogger(logdest)
        elif logtype == LOGTYPE_SYSLOG:
            self.__logger = SysLogger(logdest)
        elif logtype == LOGTYPE_STDOUT:
            self.__logger = StdoutLogger()

    def Log(self, lvl, msg):
        if lvl <= self.__verblevel:
            self.__logger._log(lvl, msg.rstrip())


    def Close(self):
        self.__logger._close()
